// IchigoLatte用8nx8n BitMap Converter
// 現在開かれている画像をPanCake用のビットマップデータに変換する
// 画像の単位はPixel（ピクセル）
// (1) 縦横が8の倍数の画像を用意する（白黒画像。モードはRGBカラー）
// (2) このプログラムをESTKまたはPhotoshop(ファイルメニュー＞スクリプト＞参照...)から実行する
(function (){
	var savefile = File.saveDialog("保存ファイル名を指定してください(*.txt)")
	if (!savefile){ return; }	// キャンセルされた場合
	//var savefile = new File("~/Desktop/0.txt");
	var flag = savefile.open("w");
	if (!flag){
		alert("ファイルが保存できません");
		return;
	}
    var docW = activeDocument.width.value;
    var docH = activeDocument.height.value;
	var jsCode = "";
	for(var y=0; y<parseInt(docH/8); y++){
		for(var x=0; x<docW/8; x++){
			var txt="";
			var totalBit = 0;
			for(var yH=0; yH<8; yH++){
				var bit = 0;
				for(var k=0; k<8; k++){
					bit=bit<<1;
					var px = x*8+k;
					var py = y*8+yH;
					var c = getPixel(px, py);
					if ((c.red > 0)||(c.green > 0)||(c.blue > 0)){ bit=bit|1; }
				}
				txt = txt+bit;
				if(yH!=7){ txt=txt+","; }
				totalBit=totalBit+bit;
			}
			if(totalBit){
				if(x==0){
					jsCode+="uart(n,14,3,x,y,c,"+txt+");\n";
				}else{
					jsCode+="uart(n,14,3,x+"+(x*8)+",y,c,"+txt+");\n";
				}
			}
		}
		jsCode+="y=y+8;\n";
	}
	$.writeln(jsCode);
	activeDocument.selection.deselect();
	
	savefile.encoding = "ASCII";
	savefile.writeln('function map(x,y,c){var n=128;');
	savefile.write(jsCode);
	savefile.writeln('}');
	savefile.writeln('uart("PC CLEAR 0b\\n");');
	savefile.writeln('map(0,0,1);');
	savefile.close();
	alert("Complete");
	//---------------------------------------------
	// ピクセル値(RGB)を取得する(8bitモード専用)
	// 戻り値はred,green,blueプロパティに入る
	//---------------------------------------------
	function getPixel(x,y){
		var R = G= B= 0,data,i;
		var docObj = activeDocument;
		docObj.selection.select([[x,y],[x+1,y],[x+1,y+1],[x,y+1],[x,y]]);
		data = docObj.channels[0].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { R = i; break; }
		data = docObj.channels[1].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { G = i; break; }
		data = docObj.channels[2].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { B = i; break; }
		return {red:R, green:G, blue:B};
	}
})();
